package db.entity.packages;

import db.Globals;
import db.entity.ClientInfo;
import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.ToString;
import lombok.extern.slf4j.Slf4j;

import java.util.List;

@Data
@Slf4j
@NoArgsConstructor
@ToString(callSuper = true)
public class ClientReadResponsePackage extends BasePackage {

    private byte port;
    private List<ClientInfo> clientInfos;

    public ClientReadResponsePackage(short responseCode) {
        super(Globals.TYPE_RESPONSE, responseCode, Globals.OPERATION_READ, Globals.PACKAGE_CLIENT_INFO, (short) 0);
    }

    @Override
    public void setPayload(ByteBuf buf) {
        port = buf.readByte();
        ClientInfo clientInfo = new ClientInfo();
        clientInfo.setConfirm(buf.readByte());
        buf.readByte(); // byte1
        clientInfo.setMac(buf.readUnsignedInt() << 16 + buf.readUnsignedShort());
        clientInfo.setIp(buf.readInt());
        buf.readByte();
        buf.readByte();
        buf.readByte();
        buf.readByte();
        clientInfos.add(clientInfo);
    }

    @Override
    public ByteBuf getPayload() {
        // TODO 这里不清楚
//        int len = clientInfosLen * 16 + 1;
//        super.setPackageLength((short) len);
        ByteBuf buf = Unpooled.buffer(0);
//        buf.writeByte(clientInfosLen);
//        buf.writeByte(port);
//        for (int i = 0; i < clientInfosLen; i++) {
//            buf.writeByte(clientInfos.get(i).getCheckResult());
//            buf.writeByte(0);
//            buf.writeByte(0);
//            buf.writeByte(0);
//            buf.writeByte(0);
//            buf.writeByte(0);
//            buf.writeInt((int) (clientInfos.get(i).getMac1() >> 16));
//            buf.writeShort((int) clientInfos.get(i).getMac1());
//            buf.writeByte(0);
//            buf.writeByte(0);
//            buf.writeInt((int) (clientInfos.get(i).getMac2() >> 16));
//            buf.writeShort((int) clientInfos.get(i).getMac2());
//            buf.writeInt(clientInfos.get(i).getIp1Mask());
//            buf.writeInt(clientInfos.get(i).getIp2Mask());
//            buf.writeShort(clientInfos.get(i).getPort1Mask());
//            buf.writeShort(clientInfos.get(i).getPort2Mask());
//        }
        return buf;
    }

}
